//
// Created by zx on 2020/7/21.
//

#ifndef NNXX_TESTS_DISPATCH_COMMUNICATOR_H
#define NNXX_TESTS_DISPATCH_COMMUNICATOR_H

#include "communication_socket_base.h"
#include "singleton.h"

#include "dispatch_message.pb.h"
#include "error_code.h"

#include "thread_safe_map.h"
#include "message_compare.h"

RegistoryCompare(message,message::Dispatch_request_msg)

class Dispatch_communicator :public Singleton<Dispatch_communicator>, public Communication_socket_base
{
    friend Singleton<Dispatch_communicator>;
public:
    virtual ~Dispatch_communicator();
    Error_manager dispatch_request(message::Dispatch_request_msg& request,message::Dispatch_response_msg& result);
    /*
     * 提前取消请求
     */
    Error_manager cancel_request(message::Dispatch_request_msg& request);
    Error_manager check_statu(int terminal_id);


protected:
    Dispatch_communicator();
    virtual Error_manager encapsulate_msg(Communication_message* message);
    virtual Error_manager execute_msg(Communication_message* p_msg);
    /*
     * 检测消息是否可被处理
     */
    virtual Error_manager check_msg(Communication_message* p_msg);
    /*
     * 心跳发送函数,重载
     */
    virtual Error_manager encapsulate_send_data();
    //检查消息是否可以被解析, 需要重载
    virtual Error_manager check_executer(Communication_message* p_msg);

    /*
     * 根据接收到的response,生成对应的 request
     */
    message::Dispatch_request_msg create_request_by_response(message::Dispatch_response_msg& msg);

private:
    thread_safe_map<message::Dispatch_request_msg,message::Dispatch_response_msg>          m_response_table;

    //调度模块状态
    message::Dispatch_status_msg                                                            m_dispatch_statu_msg;
    std::chrono::system_clock::time_point                                                   m_dispatch_statu_time;
};


#endif //NNXX_TESTS_DISPATCH_COMMUNICATOR_H
